/*
 * Copyright (c) 2013 Oracle and/or its affiliates. All rights reserved.
 *
 * @fileOverview
 * Implements a default store for lux Dashboard pattern.
 * @author Shailesh Zirpe
 */
define(['ojs/ojcore', 'knockout', 'jquery', 'ojs/ojmodel'], function(oj, ko, $) {

    var Tile = oj.Model.extend({
        idAttribute: 'tileId'
    });
    var tileModel = new Tile();

    var TileCollection = oj.Collection.extend({
        model:            tileModel,
        setURL_and_fetch: function(URL, $dfd) {
            this.url = URL;
            this.fetch({
                success: function(tilesCollection, response, options) {
                    $dfd.resolve(tilesCollection);
                },
                error: function(jqXHR, textStatus, errorThrown) {
                    oj.Logger.error('Error in collection fetch');
                }
            });
        }
    });

    return TileCollection;

});
