define([
    'gridapi.jquery',
    'gridapi.lodash'
], function ($, _) {
    'use strict';

    return {
        onMouseDown : function () {
            var that = this;
            return function (event) {
                if (event.which === 1 && $(event.target).is('.bucket-resize-anchor')) {
                    var dragChangeScaleTimeout = setTimeout(function () {
                        var position = event.pageX;
                        that.$timescaleContainer.addClass('zooming');
                        that.ganttView.$gantt.addClass('resizing-timescale');
                        var amountToZoom;
                        that.$timescaleContainer.on('mousemove.timescale-zoom', _.throttle(function (event) {
                            var change = event.pageX - position;
                            amountToZoom = parseInt(change / 4);
                            position = event.pageX;
                            that.ganttView.resizeScale({ change : amountToZoom, quick : true });
                        }, 50));
                        $(document.body).on('mouseup.timescale-zoom', function () {
                            if (amountToZoom != null) {
                                that.ganttView.resizeScale({ change : amountToZoom });
                            }
                            that.$timescaleContainer.off('mousemove.timescale-zoom');
                            $(document.body).off('mouseup.timescale-zoom');
                            that.$timescaleContainer.removeClass('zooming');
                            that.ganttView.$gantt.removeClass('resizing-timescale');
                        });
                    }, 200);
                    that.$timescaleContainer.on('mouseup.timescale-rescale', function (event) {
                        clearTimeout(dragChangeScaleTimeout);
                    });
                }
            };
        },

        onContextMenu : function () {
            var that = this;
            return function (event) {
                that.openContextMenu(event);
                return false;
            };
        }

    };
});
