define([
    'gridapi.jquery',
    'gridapi.lodash',
    'gridapi.columnMenu/menu',
    'gridapi.columnMenu/columnMenuActions',
    'ojs/ojcore',
    'knockout',
    'ojs/ojknockout',
    'ojs/ojbutton',
    'ojs/ojmenu'
], function ($, _) {
    'use strict';

    return function (grid) {
        // create menu
        var isOpen = false;
        var $menu = null;
        /*
            Problem description:
            When foucs is on lux-grid and space key is pressed (space key-up), luxgrid-evnetlistner call openColumnMenu      .... (A)
            To make menu selection, when spacekey is pressed (foucs is on ojMenu)
                key-down space fires ojMenu select
                    menu slection action is trigged
                menu is destoried
                focus is returned to the lux-grid (scorlly-grid)
                keyup event happens which by (A) causes colunnMenu to open again.
        */
        var fromKeyboardTwice = false;
        /*
        function scrollPrevent(e){ // page scrolling is annoyance while column menu is open
            if($.inArray(e.which,[37,38,39,40]) != -1) {
                e.preventDefault();
                return false;
            }
        }*/

        return {
            render: function ($th, event, fromKeyboard) {
                var that = this;
                var column = grid.columnDefinitions[$th.attr('data-index')];
                if (fromKeyboardTwice) {
                    return 'fromKeyboardTwice';
                }
                if (!grid.options.columnMenu.enabled || !column.menu) { // if column is not enabled they don't show it
                    return;
                }
                that.destroy();

                var html = '';
                html += '<ul class="lux-grid-column-menu">';
                if (column.sortable) { // someFloat column has  sortable: false
                    html += '<li id="' + grid.widget.uuid + 'columnMenuSortA' + '"' + 'data-data-index="sortA">'; // id="0columnMenuSortA"
                    html += '<a href="#"><span class="oj-menu-item-icon oj-fwk-icon oj-fwk-icon-arrow03-n" role="img"></span>' + grid.options.locale.sortAscending + '</a>';
                    html += '</li>';
                    html += '<li id="' + grid.widget.uuid + 'columnMenuSortD' + '"' + 'data-data-index="sortD">'; // id="0columnMenuSortD"
                    html += '<a href="#"><span class="oj-menu-item-icon oj-fwk-icon oj-fwk-icon-arrow03-s" role="img"></span>' + grid.options.locale.sortDescending + '</a>';
                    html += '</li>';
                    html += '<li id="divider"></li>';
                }
                html += '<li id="' + grid.widget.uuid + 'columnMenuColumnsRoot' + '"' + '>';
                html += '<a href="#">' + grid.options.locale.columnToggle + '</a>';
                html += '<ul>';
                _.forEach(grid.options.columnMenu.columnToggleMenu.dataIndexes, function (element) {
                    html += '<li id="' + grid.widget.uuid + 'columnMenuColumnsRoot' + element + '"' + 'data-data-index=' + element + '>';
                    if (grid.columnDefinitions[element].visible) { // checkbox checked
                        html += '<a href="#"><span class="oj-menu-item-icon demo-icon-font lux-oj-alta-icon-checkmark" aria-label="column selected" role="img"></span>' + grid.columnDefinitions[element].title + '</a>';
                        // html += '<a href="#"><img class="oj-menu-item-icon" src="../../css/images/qual_checkmark_16_full.png" alt="column selected"/>' + grid.columnDefinitions[element].title + '</a>';
                    } else { // checkbox unchecked
                        html += '<a href="#"><span class="oj-menu-item-icon" aria-label="column unselected" role="img"></span>' + grid.columnDefinitions[element].title + '</a>';
                    }
                    html += '</li>';
                });

                _.forEach(grid.options.columnMenu.columnToggleMenu.subMenus, function (element, index) {
                    html += '<li></li>';
                    html += '<li id="' + grid.widget.uuid + 'columnMenuSubMenu' + index + '"' + 'data-data-index=' + index + '>';
                    html += '<a href="#"><span></span>' + element.label + '</a>';
                    if (element.dataIndexes.length > 0) {
                        html += '<ul>';
                        _.forEach(element.dataIndexes, function (element, index) {
                            html += '<li id="' + grid.widget.uuid + 'columnMenuSubMenuLevel2' + index + '"' + 'data-data-index=' + element + '>';
                            if (grid.columnDefinitions[element].visible) { // checkbox checked
                                html += '<a href="#"><span class="oj-menu-item-icon demo-icon-font lux-oj-alta-icon-checkmark" aria-label="column selected" role="img"></span>' + grid.columnDefinitions[element].title + '</a>';
                            } else { // checkbox unchecked
                                html += '<a href="#"><span class="oj-menu-item-icon" aria-label="column unselected" role="img"></span>' + grid.columnDefinitions[element].title + '</a>';
                            }
                            html += '</li>';
                        });
                        html += '</ul>';
                    }
                    html += '</li>';
                });

                html += '</ul>';
                html += '</li>';
                html += '</ul>';
                html += '</li>';
                html += '</ul>';


                var $html = $(html);
                $(document.body).append($html);
                var scrollyGridId = '#' + grid.widget.uuid + 'grid'; // LUX-525 Id now needs '#'
                $menu = $html.ojMenu({
                    openOptions: {
                        launcher: scrollyGridId
                    },
                    open: that.menuOpen.bind(that),
                    close: that.menuClose.bind(that)
                });
                $menu.ojMenu('open');
                $menu.removeAttr('style');
                var position = $th.offset();
                $menu.css('position', 'absolute');
                $menu.css('left', position.left);
                $menu.css('top', position.top + $th.outerHeight());
                $menu.focus();
                $menu.on('ojselect', function (event, ui) { //ui.item.attr("id") gives item select action
                    if (fromKeyboard) {
                        fromKeyboardTwice = true;
                        setTimeout(function () {
                            fromKeyboardTwice = false;
                        }, 300);
                    }
                    var selectedVal = ui.item.data('data-index');
                    if (selectedVal === 'sortA' || selectedVal === 'sortD') {
                        if (selectedVal === 'sortA') {
                            grid.widget.sortRows(column.dataIndex, false, 'asc');
                        } else {
                            grid.widget.sortRows(column.dataIndex, false, 'dsc');
                        }
                    } else { // toggle column visibility
                        grid.switchColumnVisibilty(grid.columnDefinitions[selectedVal]);
                    }
                    return false;
                });

                // IE issue: This function makes a call to 'that.destroy()' above here, but it's not executed before this part of the code is executed.
                setTimeout(function () {
                    isOpen = true;
                }, 0);
                return $menu; // return the dropdowmn menu to gridView.js for adding aria-owns to the grid.
            },

            menuOpen: function () {},
            menuClose: function () {},

            destroy: function () {
                // $(document).off('keydown' + grid.widget.eventNamespace, scrollPrevent); // page scrolling is annoyance while column menu is open
                if ($menu != null) {
                    $menu.ojMenu('destroy');
                    $menu.remove();
                    isOpen = false;
                    $menu = null;
                    grid.widget.requestBrowserFocus(true);
                }
            },

            isOpen: function () {
                return isOpen;
            }
        };
    };
});
