define([
    'gridapi.jquery',
    'gridapi.lodash',
    'gridapi.grid/columns/core/headerRenderer',
    'gridapi.grid/gridMixins'
], function ($, _, HeaderRenderer, mixins) {
    'use strict';

    function LUXHeaderRenderer() {
        HeaderRenderer.apply(this, arguments);
    }

    LUXHeaderRenderer.extend = mixins.extendFn;

    LUXHeaderRenderer.prototype = _.assign(Object.create(HeaderRenderer.prototype), {
        getDescribedBy : function (column, options) {
            var describedby = [];
            if (column.sortable && !column.columnMenu) {
                describedby.push(options.descriptionIds.cellState.columnSort);
            }
            if (column.columnMenu) {
                describedby.push(options.descriptionIds.cellState.columnMenu);
            }
            return describedby;
        }
    });


    return LUXHeaderRenderer;
});
