define([
    'gridapi.jquery',
    'gridapi.lodash',
    'gridapi.columns/core/editor',
    'gridapi.columns/core/renderer',
    'gridapi.columns/core/headerRenderer'
], function ($, _, editor, renderer, headerRenderer) {
    'use strict';

    return {

        defaultOptions : {
            enableEditor : false,
            disableColumnFilter: false
        },
        renderer : renderer.extend({
            getValueMarkup : function (options) {
                var markup = '<a  id="' + options.id + '-link" tabindex="-1" data-trigger="link-clicked" class="cell-descendant cell-link" ';
                markup += this.getAriaLabeledBy(options);
                markup += this.getAriaDescribedBy(options);
                markup += this.getLinkAttributes(options) + ' >';
                markup += options.formattedValue + '</a>';
                return markup;
            },
            getLinkAttributes : function (/* options */) {
                return '';
            },
            getDescriptionLabel : function (renderOptions) {
                var labels = renderOptions.descriptionIds.cellState.linkCell;
                if (renderOptions.editable && !renderOptions.readOnly && !renderOptions.locked && renderOptions.column.enableEditor) {
                    labels += ' ' + renderOptions.descriptionIds.cellState.editableCell;
                }
                return labels;
            }
        }),
        headerRenderer : headerRenderer.extend({

        }),
        editor : editor.extend({
            getNewData : function () {
                var string = this.getEditorInput().val();
                if (string != null) {
                    string = string.trim();
                }
                return {
                    value : string,
                    valid : this.validateUserInput(string)
                };
            }
        })
    };
});
