define([
    'gridapi.jquery',
    'gridapi.lodash',
    'gridapi.columns/core/editor',
    'gridapi.columns/core/renderer',
    'gridapi.columns/core/headerRenderer'
], function ($, _, editor, renderer, headerRenderer) {
    'use strict';
    return {
        defaultOptions : {
            headerAlign : 'center',
            filldown: false,
            timephased : true,
            useStackedContext : true,
            resizable : true,
            width : '100px'
        },
        renderer : renderer.extend({

        }),
        headerRenderer : headerRenderer.extend({
            getClasses : function () {
                return ' timephased-column ';
            }
        }),
        editor : editor.extend({

            getNewData : function () {
                var string = this.getEditorInput().val();
                if (string != null) {
                    string = string.trim();
                }
                return {
                    value : string,
                    valid : this.validateUserInput(string)
                };
            }
        })
    };
});
