define([
    'gridapi.jquery',
    'gridapi.lodash',
    'gridapi.columns/core/renderer',
    'gridapi.columns/core/headerRenderer',
    'gridapi.columns/selectColumn'
], function ($, _, renderer, headerRenderer, selectColumn) {
    'use strict';

    return {
        defaultOptions : {
            keyboardInput: false,
            disableColumnFilter: false
        },
        editor : selectColumn.editor.extend({
            render : function () {
                this.combo.init();
                var data = {
                    id : this.isValueChecked(this.data)
                };
                this.combo.value(data);
            },
            getPossibleSelectValues : function () {
                var yesString = this.column.yes || this.grid.options.locale.yes;
                var noString = this.column.no || this.grid.options.locale.no;
                return [
                    {
                        id : true,
                        name : yesString
                    },
                    {
                        id : false,
                        name : noString
                    }
                ];
            },

            getEditorInput : function () {
                return this.getEditor();
            },

            isValueChecked : function (data) {
                return data === true || data === 'true' || data === 'Y' || data === 'yes';
            }
        }),

        headerRenderer : headerRenderer.extend({

        }),

        renderer : renderer.extend({
            format : function (renderOptions) {
                var formattedString = renderOptions.column.no || renderOptions.locale.no;
                if (this.isValueChecked(renderOptions)) {
                    formattedString = renderOptions.column.yes || renderOptions.locale.yes;
                }
                return formattedString;
            },

            isValueChecked : function (renderOptions) {
                var data = renderOptions.data;
                return data === true || data === 'true' || data === 'Y' || data === 'yes';
            }
        })
    };
});
