define([
    'gridapi.jquery',
    'gridapi.lodash',
    'gridapi.grid/columns/core/editor',
    'gridapi.grid/gridMixins'
], function ($, _, Editor, mixins) {
    'use strict';

    function PGBUEditor() {
        Editor.apply(this, arguments);
    }

    PGBUEditor.extend = mixins.extendFn;

    PGBUEditor.prototype = _.assign(Object.create(Editor.prototype), {
        closeEditorOnMouseDown : function (event) {
            if (Editor.prototype.closeEditorOnMouseDown.apply(this, arguments)) {
                var $target = $(event.target);
                var modalParents = $target.parents('.pgbu-modal').first();
                // If they click on something in a modal and that modal contains the grid close it. Otherwise expect the modal was created via some editor action
                return !(modalParents.length && !modalParents.find(this.grid.$grid).length) && !$target.is('.modal-backdrop');
            }
            return false;
        }
    });

    return PGBUEditor;
});
