define(['gridapi.lodash'], function (_) {
    'use strict';
    return {
        dataIndex: undefined, // data name in object
        title: '_no-header_', // column header text
        tooltip: '', // text displayed when hovered over column header
        headerAlign: 'left', // alignment of column header text 'left', 'right', 'center'
        align: 'left', // alignment of column data text 'left', 'right', 'center'
        width: '100px', // width of the column
        resizable: false, // can the column be resized
        draggable: false, // can the column be moved to a new column position
        displayType: 'text', // type of column to be used for renderer and editor
        dataType: 'string', // data type inside of column
        readOnly: false, // force the column data not to be editable
        filterable: false, // can the column be filtered
        sortable: false, // can the column be sorted
        hideable: false, // can the column be hidden
        menu: true, // display column menu
        maxLength: null,
        hasDisabledMode: false,
        rollupRole: null,
        rollupOrder: 0,
        enableEditor: true,
        dataDisplay: 'value',
        visible: true, // internal use only - for column menu
        minWidth: null,
        filldown: true,
        joinedColumns: [],
        columnClass: ' ',
        searchable: true,
        hideAsterisk: false,
        grouper: {
            getGroupValue: function (value) {
                return value;
            }
        },
        escaping : {
            autoEscapeRender : false,
            autoEscapeEditor : false,
            escape : _.escape.bind(_),
            unescape : _.unescape.bind(_)
        },
        allowClearCells : true

    };
});
