define(function () {
    'use strict';

    return {
        notSorted : 'Click to sort ascending',
        sortedAscending : 'Sorted ascending, click to sort descending',
        sortedDescending : 'Sorted descending, click to clear sort',
        sortAscending : 'Sort Ascending',
        sortDescending : 'Sort Descending',
        columnToggle : 'Columns',
        invalidFormatError : 'Format not correct for cell.',
        uniqueError : '{0}: Already exists. Enter a unique value.',
        loading : 'Loading...',
        required : 'Required',
        autoNumbered : 'Auto-Number',
        selectDeselect : 'Select / Deselect',
        selectDeselectAll : 'Selector Column',
        noResultsFound : 'No rows match the current filter(s).',
        selected : 'Selected',
        unselected : 'Unselected',
        gridSummary : '',
        gridUsage : 'This is a virtualized data grid, only visible rows are rendered in the browser. As you move up and down through the list more items will show. Use the arrow and Tab keys in Forms mode to navigate through the grid. Press escape to exit action mode and allow tab to take you away from the grid. F2 or Enter will open the cells editor. Pressing space will activate cells with special actions such as links, or buttons. If enabled the menu key will open a row menu for the selected rows.',  // LUX-248
        rowSelectorCol: 'Rows can be selected with the check boxes in the first column of the grid.', // LUX-277:  There is no indication by JAWS that the selector (check box) column is available.
        gridLabel : 'Data Grid',
        rowsSelected : '{0} Rows Selected',
        yes : 'Yes',
        no : 'No',
        cellToolbar_newRow : 'Add Row',
        cellToolbar_newChildRow : 'Add Child Row',
        cellToolbar_deleteRows : 'Delete Row',
        quickAddHint : 'Start typing...',
        escapeModeText : 'Press tab to skip over this grid widget. Press enter, escape or click to enter the grid.',
        noActionsAvailable : 'No Actions Available',
        noGroupValue : 'None',
        columnFilterPlaceholderText: 'Filter', // LUX-506
        sort : "Sort",
        openColumnGroupMenu : 'Open Menu',
        columnAdjustToContent : 'Adjust to fit content',
        columnHideColumn : 'Hide column',
        quickAddHintType : "record",
        popoverTooltip : "More Info",
        richTextEditor : {
            accept : "Apply",
            cancel : "Cancel",
            close : "Close"
        },
        cellState : {
            groupRowHeaderLabel : 'Group Row',
            rowHeaderLabel : 'Row',
            columnHeaderLabel : 'Column',
            cellLabel : 'Cell Value',
            editableCell : 'Press f2 or enter to open editor.',
            selected : 'Selected',
            unselected : 'Unselected',
            mixed : 'Partially selected',
            checkboxCell : 'Press space to toggle checkbox',
            checkboxCellAll : 'Press space to toggle checkbox and select or deselect all rows',
            selectRowCell : 'Press space to toggle row selection',
            linkCell : 'Press space to activate link.',
            errorOnCell : 'Opening the editor will explain why the entry is invalid', // LUX-262
            menuLabel : 'Row menu',
            submenuLabel : 'sub menu', // This should be set on the submenu title. Not here. Removed this from contextMenu.js
            menuButtonDescription : 'Press space to open row menu.',
            errorsLabel : 'Cell Errors',
            columnSort : 'Press space to sort by column.',
            columnMenu : 'Press space to open column menu.',
            collapsed: 'Press Control Right Arrow to expand', // LUX-78
            expanded: 'Press Control Left Arrow to collapse', // LUX-78
            collapsedState: 'collapsed', // LUX-78
            expandedState: 'expanded', // LUX-78
            columnFilter: 'Filter the data grid by column ', // LUX-506,
            disableColumnFilter: 'disabled',
            quickAddButtonDescription : "Press space to add a new row"
        },
        columnEditors : {
            text : 'Standard text editor input, enter text for this column.',
            textarea : 'Standard text area editor input, enter text for this column.', // Issue LUX-245, user lower-case 'a' in text'a'rea
            number : 'Enter a numerical value.',
            select : 'Combo box editor, press up and down to go through the list to select a value. Select value with enter.',
            // spinner : 'Enter a value or press up and down to increment and decrement the value.',   // remove this LUX-249
            date : 'Enter a date as text or press Down Arrow to open date picker.',
            picker : 'Press f2 to open a picker popup to select items.',
            cost : 'Enter amount', // Issue LUX-249
            percent : 'Enter percentage', // Issue LUX-249
            num_spin : ' or press up and down arrows to increment and decrement the value.' // Issue LUX-249
        },
        export : {
            fileName: 'Download',
            worksheetName: 'Sheet1',
            user : 'A User'
        },
        statusBar : {
            countLabel : "Total Records:",
            enable : "Enable",
            disable : "Disable",
            readOnlyCellStyle : "Highlight read-only cells",
            exportToExcel : "Download"
        },
        timephased : {
            weekDay : 'Week/Day',
            monthWeek : 'Month/Week',
            quarterMonth : 'Quarter/Month',
            yearMonth : 'Year/Month',
            yearQuarter : 'Year/Quarter',
            viewMore : 'Show 10 More',
            weekOf : 'Week of {0}',
            reportingPeriod : 'Reporting Period: {0}'
        },
        themeConfigurator : {
            activity : 'Activity',
            configure : 'Configure',
            theme : 'Theme',
            classic : 'Classic',
            modern : 'Modern',
            style: 'Style',
            colors : 'Colors',
            preview :'Preview',
            settings : 'Settings',
            groupingStyle : {
                modernBands : 'Horizontal bands',
                modernBrackets : 'Brackets',
                modernNotches : 'Vertical bands',
                modernLine : 'Vertical lines',
                none : 'None',
                classicBands : 'Classic P6'
            },
            groupingThemes : {
                classicPastel : 'Classic P6',
                classicVibrant : 'Vibrant',
                modernPastel : 'Pastel',
                modernHighlighter : 'Highlighter',
                modernDark : 'Dark',
                modernGrey : 'Grey'
            }
        },
        printConfigurator : {
            grid : {
                legend : "Grid",
                orientation : "Orientation",
                portrait : "Portrait",
                landscape : "Landscape",
                pages : "Fit to number of pages"
            },
            gantt : {
                legend : "Gantt",
                scale : "Scale",
                columns : "Number of Columns",
                startDate : "From",
                endDate : "To",
                repeat : "Repeat",
                repeatFirst : "First column",
                repeatAll : "All columns",
                repeatNone : "None"
            }
        },
        advancedFilters : {
            placeholder : 'Filter'
        }
    };
});
