
/**
 * A shared map of key names to their keycode values.
 * See the <a href="http://10.140.183.183:8080/job/primutils/javadoc/files/assets_primutils_utils_keyCode.js.html">source</a> for available keycodes.
 *
 * @class utils.keyCode
 * @module utils
 */
define({

    UP:    38,
    DOWN:  40,
    LEFT:  37,
    RIGHT: 39,

    SPACE:     32,
    TAB:       9,
    BACKSPACE: 8,
    ENTER:     13,
    ESC:       27,
    ESCAPE:    27,

    SHIFT: 16,
    CTRL:  17,
    ALT:   18,

    PAUSE:    19,
    CAPS:     20,
    PAGEUP:   33,
    PAGEDOWN: 34,
    END:      35,
    HOME:     36,
    INSERT:   45,
    DELETE:   46,

    F1:  112,
    F2:  113,
    F3:  114,
    F4:  115,
    F5:  116,
    F6:  117,
    F7:  118,
    F8:  119,
    F9:  120,
    F10: 121,
    F11: 122,
    F12: 123,

    NUMLOCK:    144,
    SCROLLLOCK: 145,

    LEFTSUPER:  91,
    RIGHTSUPER: 92,

    // All below since v2.13.1
    SELECT_KEY: 93,

    NUMROW_0: 48,
    NUMROW_1: 49,
    NUMROW_2: 50,
    NUMROW_3: 51,
    NUMROW_4: 52,
    NUMROW_5: 53,
    NUMROW_6: 54,
    NUMROW_7: 55,
    NUMROW_8: 56,
    NUMROW_9: 57,

    NUMPAD_0: 96,
    NUMPAD_1: 97,
    NUMPAD_2: 98,
    NUMPAD_3: 99,
    NUMPAD_4: 100,
    NUMPAD_5: 101,
    NUMPAD_6: 102,
    NUMPAD_7: 103,
    NUMPAD_8: 104,
    NUMPAD_9: 105,

    NUMPAD_DECIMAL:  110,
    NUMPAD_SUBTRACT: 109,
    NUMPAD_ADD:      107,
    NUMPAD_DIVIDE:   111,
    NUMPAD_MULTIPLY: 106,
    NUMPAD_ENTER:    108,

    DASH:    189,
    FF_DASH: 173,

    EQUALS:    187,
    FF_EQUALS: 61,

    PERIOD: 190,
    COMMA:  188,

    LETTER_A: 65, // intended for use with && event.ctrlKey
    LETTER_C: 67, // intended for use with && event.ctrlKey
    LETTER_V: 86, // intended for use with && event.ctrlKey
    LETTER_X: 88, // intended for use with && event.ctrlKey
    LETTER_Y: 89, // intended for use with && event.ctrlKey
    LETTER_Z: 90 // intended for use with && event.ctrlKey

});
