define([
    'luxDevice'
], function(
    luxDevice
) {
    'use strict';
    return {
        // The following function takes care of escaping the special characters for a given id.
        // Resolution for: LUX-1293 - Does not support special characters in JSON data.
        encodeId: function(id) {
            return id.replace(/(:|\.|\[|\]|,|=|@|\#|\$|\^)/g, '\\$1');
        },
        // The following function return CSS class name 'lux-touch-enabled' if device is detected as touch-enabled.
        getTouchEnabledStyleClassName: function() {
            var touchEnabledClassName = '';
            if (luxDevice.isAndroid() || luxDevice.isTouchDevice()) {
                touchEnabledClassName = 'lux-touch-enabled';
            }
            return touchEnabledClassName;
        }
    };
});
