/**
 * Copyright (c) 2013 - 2015 Oracle and/or its affiliates. All rights reserved.
 *
 * @fileOverview
 * The purpose of this utility is to prevent applying KO bindings to the same element multiple times.
 * To use this utility, use data-bind="preventChildrenBinding" on the HTML node. This binding will then
 * prevent applying binding to any of it's children node. You are free to call applyBindings on any of
 * it's child nodes.

 * @author Shailesh Zirpe
 */

define(['knockout'], function(ko) {
    'use strict';

    ko.bindingHandlers.preventChildrenBinding = {
        init: function(elem, valueAccessor) {
            return {controlsDescendantBindings: true};
        }
    };

    return 'preventChildrenBinding registered as KO custom binding';

});
