/*
 * Copyright (c) 2017 Oracle and/or its affiliates. All rights reserved.
 *
 * @fileOverview
 * Bootstrap file to register the basic LUX grid composite component.
 *
 * @author Daniel Hoang
 */
define([
    'ojs/ojcore',
    './viewModel',
    'text!./view.html',
    'text!./component.json',
    'css!./styles',
    'ojs/ojcomposite'
],
function (oj, viewModel, view, metadata) {
    'use strict';

    // Custom parsing logic goes here which can also return defaultParseFunction(value) for
    // The Composite Component registration process only takes place once for a particular composite,
    // no matter how many instances are being used in the view. During that registration call, if the
    // object passed to the viewModel property is a constructor function then, as each new instance
    // of the physical Composite Component is created on the view, the framework will use this constructor
    // to create a corresponding viewModel.
    oj.Composite.register('oj-lux-grid-basic', {
        // The ViewModel provided at registration can either be a function which will be treated as:
        // 1. a constructor that will be invoked to create the ViewModel instance
        // 2. an object which will be treated as a singleton instance
        viewModel: viewModel,
        view:      view,
        metadata:  JSON.parse(metadata)
    });
}
);
