/*
 * Copyright (c) 2018 Oracle and/or its affiliates. All rights reserved.
 * @author Daniel Hoang
 */

/*
 * This implements a composite component for a general-purpose toolbar creation.
 * Toolbar items are specified declaratively from a JSON object, and the toolbar items
 * will be rendered in the JET ojToolbar accordingly.
 */
define([
    'ojs/ojcore',
    './viewModel',
    'text!./view.html',
    'text!./component.json',
    'css!./styles',
    'ojs/ojcomposite'
],
function(oj, viewModel, view, metadata) {
    'use strict';
    oj.Composite.register('oj-lux-toolbar', {
        view:      view,
        viewModel: viewModel,
        metadata:  JSON.parse(metadata)
    });
});
