/**
 * Copyright (c) 2014, 2016, Oracle and/or its affiliates.
 * The Universal Permissive License (UPL), Version 1.0
 */
"use strict";

requirejs.config(
{
  // Path mappings for the logical module names
  paths:
  //injector:mainReleasePaths
  {
    'knockout': 'libs/knockout/knockout-3.4.2',
    'jquery': 'libs/jquery/jquery-3.3.1.min',
    'jqueryui-amd': 'libs/jquery/jqueryui-amd-1.12.1.min',
    'ojs': 'libs/oj/v5.1.0/min',
    'ojL10n': 'libs/oj/v5.1.0/ojL10n',
    'ojtranslations': 'libs/oj/v5.1.0/resources',
    'text': 'libs/require/text',
    'promise': 'libs/es6-promise/es6-promise.min',
    'hammerjs': 'libs/hammer/hammer-2.0.8.min',
    'signals': 'libs/js-signals/signals.min',
    'ojdnd': 'libs/dnd-polyfill/dnd-polyfill-1.0.0.min',
    'css': 'libs/require-css/css.min',
    'customElements': 'libs/webcomponents/custom-elements.min',
    'proj4': 'libs/proj4js/dist/proj4'
  }
  //endinjector
  ,
  // Shim configurations for modules that do not expose AMD
  shim:
  {
    "jquery":
    {
      exports: ["jQuery", "$"]
    }
  }
}
);

require(["ojs/ojcore", "knockout", "jquery", "ojs/ojknockout", "ojs/ojnavigationlist", "ojs/ojcollapsible", "ojs/ojoffcanvas"],
  function(oj, ko, $)
  {
    function MainViewModel()
    {
      var self = this;

      self.toggleDrawer = function() {
        oj.OffcanvasUtils.open({"selector": "#sidebar"});
      }
    };

    $(document).ready(function()
    {
      console.log("loaded!");
      ko.applyBindings(new MainViewModel(), document.getElementById("mainContent"));
    });
  }
);
